{-# LANGUAGE ParallelListComp, RecordWildCards, NamedFieldPuns, TemplateHaskell, DeriveDataTypeable, DeriveGeneric, ScopedTypeVariables, TypeFamilies, RankNTypes, MultiParamTypeClasses, FlexibleInstances, FlexibleContexts #-}



{- |

Module: BaselMachine.AesonUtil

Description : Internal module.

Copyright   : © 2019 W. Garrett Mitchener

License     : GPL-3

Maintainer  : garrett.mitchener@gmail.com

Stability   : experimental

Portability : non-portable (GHC, POSIX)


-}

module BaselMachine.AesonUtil where

-- import GHC.Generics

import Data.Aeson
-- import Data.Aeson.TH
import Data.Char
-- import Data.List

stripFirstWordAndLower :: String -> String

stripFirstWordAndLower chars =
  let
    x:xs = dropWhile isLower (drop 1 chars)
  in
    toLower x : xs

firstToLower :: String -> String

firstToLower (x:xs) = toLower x : xs

aesonOptions :: Options

aesonOptions =
  defaultOptions {
  fieldLabelModifier = stripFirstWordAndLower
}
