{-# LANGUAGE RecordWildCards, NamedFieldPuns, ScopedTypeVariables, DeriveDataTypeable, DeriveGeneric, TemplateHaskell #-}

{-|

Module: Digiostelium.QueryRequest

Description : Ways to query agents

Copyright   : © 2017 W. Garrett Mitchener

License     : GPL-3

Maintainer  : garrett.mitchener@gmail.com

Stability   : experimental

Portability : non-portable (GHC, POSIX)

Possible ways of querying an agent.  These datatypes are
declared in their own module to avoid name clashes with
"QueryResult".

-}

module Digiostelium.OldQueryRequest where

import GHC.Generics

import Data.Aeson
import Data.Aeson.TH
import Data.Data
import Data.Typeable

import Digiostelium.AesonUtil


-- | Information that can be extracted from a single 'Agent';
-- These are parellel to 'QueryResult.AgentResult'.
data AgentRequest =
  JustAgent
  | Summary
  | Export
  | Program
  | GenomeDetails
  deriving (Read, Show, Eq, Ord, Data, Typeable, Generic)

$(deriveJSON myJSONOpts ''AgentRequest)
