module Main where

import Control.Concurrent
import System.Posix.FileMutex
import Text.Printf

main :: IO ()
main = do
  let lockFile = "Lock.txt"
  mRes <- withLock lockFile $ do
    printf "Sleeping\n"
      -- 10 microseconds
    threadDelay (10 * 1000 * 1000)
    printf "Done\n"
  case mRes of
    Just result -> do
      printf "Result: %s\n" (show result)
    Nothing -> do
      mRes <- readLockHolder lockFile
      case mRes of
        Just (hostname, pid) -> do
          printf "Lock held by process %d on %s\n" pid hostname
        Nothing -> do
          printf "Hmm, lock holder not available\n"
